﻿;/ ===================================
;/ =  ToolBarExModule [PB 5.6x]  =
;/ ===================================
;/
;/ Custom graphical toolbars
;/
;/ based on IconBarGadged by "kenmo" (05/2016)
;/
;/ Module by Thorsten1867 (11/2017)
;/

;{ ----- GridEx Commands -----

  ; ToolBar::AddItem()
  ; ToolBar::AutoSize()
  ; ToolBar::Button()
  ; ToolBar::ClearItems()
  ; ToolBar::CountItems()
  ; ToolBar::Disable()
  ; ToolBar::DisableItem()
  ; ToolBar::Free()
  ; ToolBar::Gadget()
  ; ToolBar::GetAttribute()  
  ; ToolBar::GetColor()
  ; ToolBar::GetDisplayMode()
  ; ToolBar::GetFitHeight()
  ; ToolBar::GetFitWidth()
  ; ToolBar::GetFontID()
  ; ToolBar::GetItemText()
  ; ToolBar::GetLatchItem()  
  ; ToolBar::GetMargin()
  ; ToolBar::GetPadding()
  ; ToolBar::GetPopupMenu()  
  ; ToolBar::GetRadius()  
  ; ToolBar::GetReturnValue()  
  ; ToolBar::GetSpacing()
  ; ToolBar::GetViewHeight()
  ; ToolBar::GetViewWidth()
  ; ToolBar::Hide()
  ; ToolBar::IconDivider()
  ; ToolBar::ItemNumberFromPosition()  
  ; ToolBar::LockRedraw()
  ; ToolBar::LockSizes()
  ; ToolBar::PositionFromItemNumber()  
  ; ToolBar::RemoveItem()
  ; ToolBar::Resize()
  ; ToolBar::SetColor()
  ; ToolBar::SetDisplayMode() 
  ; ToolBar::SetFont()
  ; ToolBar::SetItemText()
  ; ToolBar::SetLatchItem()  
  ; ToolBar::SetMargin()
  ; ToolBar::SetMouseOverEvents()
  ; ToolBar::SetPadding()
  ; ToolBar::SetPopupMenu()  
  ; ToolBar::SetRadius()
  ; ToolBar::SetReturnValue()  
  ; ToolBar::SetSpacing()

;} ---------------------------

DeclareModule ToolBar
  
  ;{ ----- Constants -----
  #TBEx_Version = 130
  
  EnumerationBinary 
    #Update
    #Redraw
    #Colors
  EndEnumeration
  
  EnumerationBinary 
    #BackColor
    #TextColor
    #DividerColor
    #HighlightColor
    #Margin
    #Padding
    #Spacing
    #Radius
    #DisplayMode
    #ReturnValue
    #MouseOverEvents
    #PopupMenu
    #FontID
    #LatchItem
    #LatchColor
    #Width
    #Height
    #FitWidth
    #FitHeight
    #UserData
    #ItemNumber
    #Position
  EndEnumeration
  
  EnumerationBinary ; Display Modes
    #ImageOnly 
    #TextOnly
    #ImageAndText
  EndEnumeration
  
  Enumeration       ; Common constants
    #First   =  0
    #Last    = -1
    #None    = -1
    #All     = -2
    #Invalid = -1
    #Toggle  = -2
    #Auto    = #PB_Ignore - 1
  EndEnumeration
  
  EnumerationBinary ; Text Types
    #Label
    #ToolTip
  EndEnumeration
  
  EnumerationBinary ; ToolBarEx Item Types
    #Item
    #Divider
    #Spacer
  EndEnumeration
  
  Enumeration
    #EventType_MouseOver = #PB_EventType_FirstCustomValue
    #EventType_LeftClick = #PB_EventType_LeftClick
  EndEnumeration
  ;}
  
  Declare.i AddItem(GID.i, Text.s, Image.i=#None, ItemUserData.i=#Null, MenuItemID.i=#None, Position.i=#Last)
  Declare.i AutoSize(GID.i)
  Declare.i Button(Window.i, GID.i, X.i, Y.i, Width.i, Height.i, Image.i, Text.s="", DisplayMode.i=#PB_Default)
  Declare   ClearItems(GID.i)
  Declare.i CountItems(GID.i, IncludeNonItems.i=#False)
  Declare.i Disable(GID.i, State.i=#True)
  Declare.i DisableItem(GID.i, ItemNumber.i, State.i = #True)
  Declare.i Divider(GID.i, Position.i=#Last)
  Declare   Free(GID.i, FreeImages.i=#False)
  Declare.i Gadget(WinID.i, GadgetID.i, X.i, Y.i, Width.i, Height.i, DisplayMode.i=#PB_Default)
  Declare.i GetAttribute(GID.i, Attribute.i)  
  Declare.i GetColor(GID.i, ColorType.i)
  Declare.i GetDisplayMode(GID.i)
  Declare.i GetFitHeight(GID.i)
  Declare.i GetFitWidth(GID.i)
  Declare.i GetFontID(GID.i)
  Declare.s GetItemText(GID.i, ItemNumber.i=#First, TextType.i=#PB_Default)
  Declare.i GetLatchItem(GID.i)  
  Declare.i GetMargin(GID.i)
  Declare.i GetPadding(GID.i)
  Declare.i GetPopupMenu(GID.i)  
  Declare.i GetRadius(GID.i)
  Declare.i GetReturnValue(GID.i)  
  Declare.i GetSpacing(GID.i)
  Declare.i GetViewHeight(GID.i)
  Declare.i GetViewWidth(GID.i)
  Declare.i Hide(GID.i, State.i = #True)
  Declare.i ItemNumberFromPosition(GID.i, Position.i)
  Declare.i LockRedraw(GID.i, State.i=#True)
  Declare.i LockSizes(GID.i, State.i = #True)
  Declare.i PositionFromItemNumber(GID.i, ItemNumber.i)
  Declare   RemoveItem(GID.i, Position.i=#Last)
  Declare.i Resize(GID.i, X.i, Y.i, Width.i, Height.i)
  Declare   SetColor(GID.i, ColorType.i, Color.i=#PB_Default)
  Declare   SetDisplayMode(GID.i, Mode.i=#PB_Default)
  Declare   SetFont(GID.i, FontID.i=#PB_Default)
  Declare   SetItemText(GID.i, Text.s, ItemNumber.i=#First, TextType.i=#PB_Default)
  Declare   SetLatchItem(GID.i, ItemNumber.i=#None)  
  Declare   SetMargin(GID.i, Size.i=#PB_Default)
  Declare   SetMouseOverEvents(GID.i, State.i=#True)
  Declare   SetPadding(GID.i, Size.i=#PB_Default)  
  Declare   SetPopupMenu(GID.i, Menu.i=#PB_Default)
  Declare   SetRadius(GID.i, Size.i=#PB_Default)
  Declare   SetReturnValue(GID.i, ReturnValue.i=#PB_Default)
  Declare   SetSpacing(GID.i, Size.i=#PB_Default)
  Declare   Spacer(GID.i, Width.i=#Auto, Position.i=#Last)
  
EndDeclareModule

Module ToolBar
  
  EnableExplicit
  
  ;{ ------ Constants ------
  #TBEx_MouseOver     = $010000 ; ToolBarEx EventType Flags
  #TBEx_UseWinAPIText = Bool(#PB_Compiler_OS = #PB_OS_Windows And #True) ; Compile Switched

  EnumerationBinary ; ToolBarEx States
    #Hovering
    #Clicking
  EndEnumeration
  
  EnumerationBinary ; ToolBarEx Flags
    #TBEx_Locked
    #TBEx_Disabled
    #TBEx_Hidden
    #TBEx_SizeLock
  EndEnumeration
  ;} -----------------------
  
  ;{ ------ Structures -----
  Structure ToolBarEx_Defaults  ;{
    FontID.i
    TextColor.i
    BackColor.i
    DividerColor.i
    HighlightColor.i
    LatchColor.i
    Margin.i
    Padding.i
    Spacing.i
    Radius.i
    DisplayMode.i
    ReturnValue.i 
    MouseOverEvents.i
    PopupMenu.i
    UserData.i
  EndStructure ;}
  
  
  Structure Item_Structure    ;{
    Type.i
    ItemNumber.i
    UserData.i
    MenuID.i
    Flags.i
    Text.s
    Tip.s
    Lines.i
    TextWidth.i
    Image.i
    ImgWidth.i
    ImgHeight.i
    X.i
    Y.i
    Width.i
    Height.i
  EndStructure ;}
  
  Structure Mouse_Structure   ;{
    State.i
    HoverItem.i
    ClickItem.i
    LatchItem.i
  EndStructure ;}
  
  Structure Size_Structure    ;{
    Width.i
    Height.i
  EndStructure ;}
  
  Structure Color_Structure   ;{
    Back.i
    Text.i
    Div.i
    High.i
    Fade.i
    Click.i
    TextDisabled.i
    Latch.i
  EndStructure ;}
  
  Structure ToolBarEx_Structure ;{
    WinID.i
    Flags.i
    FontID.i
    UserData.i
    ReturnValue.i
    Popup.i
    
    Margin.i
    Padding.i
    Spacing.i
    
    Radius.i
    DisplayMode.i
    
    View.Size_Structure
    Ideal.Size_Structure
    Used.Size_Structure
    Text.Size_Structure
    MaxImg.Size_Structure
    MaxText.Size_Structure
    
    Color.Color_Structure
    
    Mouse.Mouse_Structure
    
    NumPositions.i
    NumItems.i
    List Pos.Item_Structure()
    
  EndStructure ;}
  ;}
  
  Global GadgetDefault.ToolBarEx_Defaults
  Global NewMap TBEx.ToolBarEx_Structure()
  
  CompilerIf #TBEx_UseWinAPIText
    
    Procedure _TBExText(_did.i, _x.i, _y.i, _Text.s, _Fore.i, _Back.i)
      Protected _Rect.RECT
      _Rect\left   = _x
      _Rect\top    = _y
      _Rect\right  = OutputWidth()
      _Rect\bottom = OutputHeight()
      SetTextColor_(_did, _Fore)
      SetBkColor_(_did, _Back)
      DrawText_(_did, _Text, -1, @_Rect, #DT_SINGLELINE | #DT_NOPREFIX)
    EndProcedure
    
  CompilerElse
    
    Macro _TBExText(_did, _x, _y, _Text, _Fore, _Back)
      DrawText((_x), (_y), (_Text), (_Fore), (_Back))
    EndMacro
    
  CompilerEndIf
  
  Procedure.i _CountItems(GID.i)
    Define Result.i = 0
    
    If FindMapElement(TBEx(), Str(GID))
      
      ForEach TBEx()\Pos()
        Select TBEx()\Pos()\Type
          Case #Item
            TBEx()\Pos()\ItemNumber = Result
            Result + 1
          Default
            TBEx()\Pos()\ItemNumber = #Invalid
        EndSelect
      Next
      
      TBEx()\NumItems = Result
      
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  ;- ----- Public Procedures ------
  Declare Update(GID.i, Redraw.i=#False)
  Declare Redraw(GID.i, Force.i=#False)
  Declare CalculateColors(GID.i)
  Declare FormatText(GID.i)
  Declare ToolBarExCallback()
  
  Procedure   Refresh(GID.i, Flags.i)
    If Flags & #Update : Update(GID) : EndIf
    If Flags & #Redraw : Redraw(GID) : EndIf
    If Flags & #Colors : CalculateColors(GID) : EndIf
  EndProcedure
  
  Procedure.i Resize(GID.i, X.i, Y.i, Width.i, Height.i)
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Width = #Auto
        If TBEx()\Ideal\Width > 0
          Width = TBEx()\Ideal\Width
        Else
          Width = #PB_Ignore
        EndIf
      EndIf
      If Height = #Auto
        If TBEx()\Ideal\Height > 0
          Height = TBEx()\Ideal\Height
        Else
          Height = #PB_Ignore
        EndIf
      EndIf
      
      ResizeGadget(GID, X, Y, Width, Height)
      
      Update(GID, #True)
      
      ProcedureReturn TBEx()\View\Height
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure  
  
  Procedure.i AutoSize(GID.i)  ; Size an ToolBarEx to show (position not affected)
    ProcedureReturn  Resize(GID, #PB_Ignore, #PB_Ignore, #Auto, #Auto)
  EndProcedure
  
  Procedure.i LockRedraw(GID.i, State.i=#True)
    ; Lock ToolBarEx redraw (True, False, or #Toggle)
    ; Returns the new state
    
    If FindMapElement(TBEx(), Str(GID))
      
      If State = #Toggle
        State = Bool(Not (TBEx()\Flags & #TBEx_Locked))
      EndIf
      
      If State And TBEx()\Flags & #TBEx_Locked = #False
        TBEx()\Flags | #TBEx_Locked
      ElseIf ((Not State) And (TBEx()\Flags & #TBEx_Locked))
        TBEx()\Flags & ~#TBEx_Locked
        Redraw(GID)
      EndIf
      
      ProcedureReturn Bool(State)
      
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure
 
  Procedure.i LockSizes(GID.i, State.i=#True)
    ; Lock ToolBarEx item sizes (True, False, or #Toggle)
    ; Returns the new state
    ; (Useful if you want to change Item text without changing the Item size)  
    
    If FindMapElement(TBEx(), Str(GID))
      
      If State = #Toggle
        State = Bool(Not (TBEx()\Flags & #TBEx_SizeLock))
      EndIf
      
      If State And TBEx()\Flags & #TBEx_SizeLock = #False
        TBEx()\Flags | #TBEx_SizeLock
      ElseIf State = #False And TBEx()\Flags & #TBEx_SizeLock
        TBEx()\Flags & ~#TBEx_SizeLock
        Update(GID, #True)
      EndIf
      
      ProcedureReturn Bool(State)
      
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure
  
  Procedure.i Disable(GID.i, State.i=#True)
    ; Disable an ToolBarEx (True, False, or #Toggle)
    ; Returns the new state 
    
    If FindMapElement(TBEx(), Str(GID))
      
      Select State
        Case #Toggle
          If TBEx()\Flags & #TBEx_Disabled
            TBEx()\Flags & ~#TBEx_Disabled
            State = #False
          Else
            TBEx()\Flags | #TBEx_Disabled
            State = #True
          EndIf
          TBEx()\Mouse\State     = #Hovering
          TBEx()\Mouse\HoverItem = #None
          Redraw(GID)
          ProcedureReturn State
        Case #True
          TBEx()\Flags | #TBEx_Disabled
          TBEx()\Mouse\State     = #Hovering
          TBEx()\Mouse\HoverItem = #None
          Redraw(GID)
          ProcedureReturn #True
        Case #False
          TBEx()\Flags & ~#TBEx_Disabled
          TBEx()\Mouse\State     = #Hovering
          TBEx()\Mouse\HoverItem = #None
          Redraw(GID)
          ProcedureReturn #False
      EndSelect
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure

  Procedure.i DisableItem(GID.i, ItemNumber.i, State.i = #True)
    ; Disable an individual ToolBarEx item (True, False, or #Toggle)
    ; Returns the new state
    ; You can also pass #All as the ItemNumber
    Define.i AllItems, Toggle
    Define.i Result = #Invalid
    
    
    If FindMapElement(TBEx(), Str(GID))
      
      If ItemNumber = #Last : ItemNumber = TBEx()\NumItems - 1 : EndIf
      
      AllItems = Bool(ItemNumber = #All)
      Toggle   = Bool(State = #Toggle)
      
      If (ItemNumber >= 0 And ItemNumber < TBEx()\NumItems) Or AllItems
        
        ForEach TBEx()\Pos()
          
          If TBEx()\Pos()\Type = #Item
            
            If (TBEx()\Pos()\ItemNumber = ItemNumber) Or AllItems
              
              If Toggle
                State = Bool(Not (TBEx()\Pos()\Flags & #TBEx_Disabled))
              EndIf
              
              If State And TBEx()\Pos()\Flags & #TBEx_Disabled = #False
                TBEx()\Pos()\Flags | #TBEx_Disabled
              ElseIf State = #False And TBEx()\Pos()\Flags & #TBEx_Disabled
                TBEx()\Pos()\Flags & ~#TBEx_Disabled
              EndIf
              
              Result = Bool(State)
              
              If AllItems = #False : Break : EndIf
              
            EndIf
            
          EndIf
          
        Next
        
        Update(GID, #True)
        
      EndIf
      
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure SetItemText(GID.i, Text.s, ItemNumber.i=#First, TextType.i=#PB_Default)
    ; Set an ToolBarEx item's text (specified by item number, clickable items only)
    ; TextType can be Label or ToolTip
    
    If FindMapElement(TBEx(), Str(GID))
      
      If ItemNumber = #Last     : ItemNumber = TBEx()\NumItems - 1 : EndIf
      If TextType = #PB_Default : TextType = #Label               : EndIf
      
      If PositionFromItemNumber(GID, ItemNumber) >= 0
        
        If TBEx()\Pos()\Type = #Item
          Select TextType
            Case #ToolTip
              TBEx()\Pos()\Tip = Text
            Default
              TBEx()\Pos()\Text = Text
          EndSelect
          FormatText(GID)
          Update(GID, #True)
        EndIf
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure.i PositionFromItemNumber(GID.i, ItemNumber.i)
    ; Convert an ToolBarEx Item Number (zero-based - only includes clickable items)
    ; to a position index (zero-based - includes dividers and spacers)  
    Define Result.i = #Invalid
    
    If FindMapElement(TBEx(), Str(GID))
      
      If ItemNumber = #Last : ItemNumber = TBEx()\NumItems - 1 : EndIf
      
      If ItemNumber >= 0 And ItemNumber < TBEx()\NumItems
        ForEach TBEx()\Pos()
          If TBEx()\Pos()\ItemNumber = ItemNumber
            Result = ListIndex(TBEx()\Pos())
            Break
          EndIf
        Next
      EndIf
      
    EndIf
    
    ProcedureReturn Result
  EndProcedure  
  
  Procedure.i ItemNumberFromPosition(GID.i, Position.i)
    ; Convert an ToolBarEx position index (zero-based - includes dividers and spacers)
    ; to an Item Number (zero-based - only includes clickable items)    
    Define Result.i = #Invalid
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Position = #Last : Position = TBEx()\NumPositions - 1 : EndIf
      
      If Position >= 0 And Position < TBEx()\NumPositions
        SelectElement(TBEx()\Pos(), Position)
        Result = TBEx()\Pos()\ItemNumber
      EndIf
      
    EndIf
    
    ProcedureReturn (Result)
  EndProcedure
  
  Procedure.i Hide(GID.i, State.i = #True)
    ; Hide an ToolBarEx (True, False, or #Toggle)
    ; Returns the new state  
    Define Result.i = #Invalid
    
    If FindMapElement(TBEx(), Str(GID))
      
      If State = #Toggle
        State = Bool(Not (TBEx()\Flags & #TBEx_Hidden))
      EndIf
      
      If State And TBEx()\Flags & #TBEx_Hidden = #False
        HideGadget(GID, #True)
        TBEx()\Flags | #TBEx_Hidden
        TBEx()\Mouse\State     = #Hovering
        TBEx()\Mouse\HoverItem = #None
      ElseIf ((Not State) And (TBEx()\Flags & #TBEx_Hidden))
        HideGadget(GID, #False)
        TBEx()\Flags & ~#TBEx_Hidden
        TBEx()\Mouse\State     = #Hovering
        TBEx()\Mouse\HoverItem = #None
        Redraw(GID)
      EndIf
      
      Result = Bool(State)
      
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure.i AddItem(GID.i, Text.s, Image.i=#None, ItemUserData.i=#Null, MenuItemID.i=#None, Position.i=#Last)
    ; Add a clickable ToolBarEx item
    ; - Text: Tooltip or displayed text, depending on Display Mode
    ; - Image: Displayed icon, depending on Display Mode
    ; - UserData: Optional data, can be reported on clicks by Return Value Mode
    ; - MenuItemID: Optional, if specified, will generate a PB Menu event when clicked
    ; - Position: A specific position, or the end of the bar by default 
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Position = #Last : Position = TBEx()\NumPositions : EndIf
      
      If Position <= TBEx()\NumPositions
        
        If Position = TBEx()\NumPositions
          LastElement(TBEx()\Pos())
          AddElement(TBEx()\Pos())
        Else
          SelectElement(TBEx()\Pos(), Position)
          InsertElement(TBEx()\Pos())
        EndIf
        
        TBEx()\Pos()\Text =  Text
        
        If TBEx()\DisplayMode = #ImageOnly : TBEx()\Pos()\Tip = Text : EndIf
        
        FormatText(GID)
        
        TBEx()\Pos()\Image    = Image
        TBEx()\Pos()\UserData = ItemUserData
        TBEx()\Pos()\MenuID   = MenuItemID
        TBEx()\Pos()\Type     = #Item
        TBEx()\NumPositions + 1
        
        If TBEx()\Pos()\Image <> #None
          If IsImage(TBEx()\Pos()\Image)
            TBEx()\Pos()\ImgWidth  = ImageWidth(TBEx()\Pos()\Image)
            TBEx()\Pos()\ImgHeight = ImageHeight(TBEx()\Pos()\Image)
          Else
            TBEx()\Pos()\Image = #None
          EndIf
        EndIf
        
        _CountItems(GID)
        Update(GID, #True)
        
        ProcedureReturn Position
      EndIf
      
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure
  
  Procedure   RemoveItem(GID.i, Position.i=#Last)
    ; Remove an ToolBarEx item (icon, divider, or spacer) by position
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Position = #Last : Position = TBEx()\NumPositions - 1 : EndIf
      
      If Position >= 0 And Position < TBEx()\NumPositions
        SelectElement(TBEx()\Pos(), Position)
        DeleteElement(TBEx()\Pos())
        TBEx()\NumPositions - 1
        _CountItems(GID)
        Update(GID, #True)
      EndIf
      
    EndIf
    
  EndProcedure  
  
  Procedure   ClearItems(GID.i)
    ; Remove all items from an ToolBarEx
    
    If FindMapElement(TBEx(), Str(GID))
      
      ClearList(TBEx()\Pos())
      TBEx()\NumPositions = 0
      TBEx()\NumItems     = 0
      
      Update(GID, #True)
      
    EndIf
    
  EndProcedure
  
  Procedure.i CountItems(GID.i, IncludeNonItems.i=#False)
    ; Returns the number of ToolBarEx items (or all positions, including dividers and spacers)
    
    If FindMapElement(TBEx(), Str(GID))
      
      If IncludeNonItems
        ProcedureReturn TBEx()\NumPositions
      Else
        ProcedureReturn TBEx()\NumItems
      EndIf
      
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure
  
  Procedure.i Divider(GID.i, Position.i=#Last)
    ; Add an ToolBarEx divider (vertical line between items)  
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Position = #Last : Position = TBEx()\NumPositions : EndIf
      
      If Position <= TBEx()\NumPositions
        
        If Position = TBEx()\NumPositions
          LastElement(TBEx()\Pos())
          AddElement(TBEx()\Pos())
        Else
          SelectElement(TBEx()\Pos(), Position)
          InsertElement(TBEx()\Pos())
        EndIf
        
        TBEx()\Pos()\Type = #Divider
        TBEx()\NumPositions + 1
        
        Update(GID, #True)
        
       ProcedureReturn Position
     EndIf
     
    EndIf
    
    ProcedureReturn #Invalid
    
  EndProcedure
  
  Procedure.i Spacer(GID.i, Width.i=#Auto, Position.i=#Last)
    ; Add an ToolBarEx spacer (empty section which automatically fills any extra horizontal space)
    ; You can right-justify an ToolBarEx by adding a spacer in the left-most position
    ; You can center-justify an ToolBarEx by adding a spacer at each end
    ; You can place a spacer between icons to force them to the left and right sides
    ; You can use other combinations of spacers to achieve many layouts  
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Position = #Last : Position = TBEx()\NumPositions : EndIf
      
      If Position <= TBEx()\NumPositions
        
        If Position = TBEx()\NumPositions
          LastElement(TBEx()\Pos())
          AddElement(TBEx()\Pos())
        Else
          SelectElement(TBEx()\Pos(), Position)
          InsertElement(TBEx()\Pos())
        EndIf
        
        TBEx()\Pos()\Type = #Spacer
        
        If Width >= 0
          TBEx()\Pos()\TextWidth = Width
        Else
          TBEx()\Pos()\TextWidth = #PB_Default
        EndIf
        
        TBEx()\NumPositions + 1
        
        Update(GID, #True)
        
        ProcedureReturn Position
      EndIf
      
    EndIf
    
    ProcedureReturn #Invalid
  EndProcedure  
  
  Procedure.i Free(GID.i, FreeImages.i=#False)
    ; Removes an ToolBarEx and releases all its memory
    
    If FindMapElement(TBEx(), Str(GID))
      
      If IsGadget(GID)
        UnbindGadgetEvent(GID, @ToolBarExCallback())
        FreeGadget(GID)
      EndIf
      
      If FreeImages
        ForEach TBEx()\Pos()
          If IsImage(TBEx()\Pos()\Image)
            FreeImage(TBEx()\Pos()\Image)
          EndIf
        Next
      EndIf
      
      DeleteMapElement(TBEx())

    EndIf
    
    ProcedureReturn (#Null)
  EndProcedure  
 
  
  Procedure.i Button(WindowID.i, GadgetID.i, X.i, Y.i, Width.i, Height.i, Image.i, Text.s = "", DisplayMode.i=#PB_Default)
    ; A helper function to create a single-item ToolBarEx which acts like a button gadget
    Define.i GID
    
    GID = Gadget(WindowID, GadgetID, X, Y, Width, Height, DisplayMode)
    If GID
      If GadgetID = #PB_Any : GadgetID = GID : EndIf
      SetMargin(GadgetID, 0)
      AddItem(GadgetID, Text, Image)
      LockSizes(GadgetID, #True)
    EndIf
    
    ProcedureReturn GadgetID
  EndProcedure
  
  
  Procedure.s GetItemText(GID.i, ItemNumber.i=#First, TextType.i=#PB_Default)
    ; Get an ToolBarEx item's text (specified by item number, clickable items only)
    ; TextType can be Label or ToolTip  
    Define Result.s = ""
    
    If FindMapElement(TBEx(), Str(GID))
      
      If ItemNumber = #Last : ItemNumber = TBEx()\NumItems - 1 : EndIf
      
      If PositionFromItemNumber(GID, ItemNumber) >= 0
        If TBEx()\Pos()\Type = #Item
          Select TextType
            Case #ToolTip
              Result = TBEx()\Pos()\Tip
            Default
              Result = TBEx()\Pos()\Text
          EndSelect
        EndIf
      EndIf
      
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
  Procedure.i GetColor(GID.i, ColorType.i)
    ; Get an ToolBarEx color
    Define Result.i = #Invalid
    
    If FindMapElement(TBEx(), Str(GID))
      
      Select ColorType
        Case #BackColor
          ProcedureReturn TBEx()\Color\Back
        Case #TextColor
          ProcedureReturn TBEx()\Color\Text
        Case #DividerColor
          ProcedureReturn TBEx()\Color\Div
        Case #HighlightColor
          ProcedureReturn TBEx()\Color\High
        Case #LatchColor
          ProcedureReturn TBEx()\Color\Latch
      EndSelect
      
    EndIf

  EndProcedure  
  
  Procedure.i GetAttribute(GID.i, Attribute.i)
    ; Get an ToolBarEx attribute (including some read-only attributes)
    Define Result.i = #Invalid
    
    If FindMapElement(TBEx(), Str(GID))
      
      Select Attribute
        Case #Margin
          ProcedureReturn TBEx()\Margin
        Case #Padding
          ProcedureReturn TBEx()\Padding
        Case #Spacing
          ProcedureReturn TBEx()\Spacing
        Case #Radius
          ProcedureReturn TBEx()\Radius
        Case #DisplayMode
          ProcedureReturn TBEx()\DisplayMode
        Case #ReturnValue
          ProcedureReturn TBEx()\ReturnValue
        Case #MouseOverEvents
          ProcedureReturn Bool(TBEx()\Flags & #TBEx_MouseOver)
        Case #PopupMenu
          ProcedureReturn TBEx()\Popup
        Case #FontID
          ProcedureReturn TBEx()\FontID
        Case #UserData
          ProcedureReturn TBEx()\UserData
        Case #LatchItem
          ProcedureReturn TBEx()\Mouse\LatchItem
        Case #Width
          ProcedureReturn TBEx()\View\Width
        Case #Height
          ProcedureReturn TBEx()\View\Height
        Case #FitWidth
          ProcedureReturn TBEx()\Ideal\Width
        Case #FitHeight
          ProcedureReturn TBEx()\Ideal\Height
      EndSelect
      
    EndIf
    
  EndProcedure

  Procedure.i GetMargin(GID.i)
    ProcedureReturn TBEx()\Margin
  EndProcedure
  
  Procedure.i GetPadding(GID.i)
    ProcedureReturn TBEx()\Padding
  EndProcedure
  
  Procedure.i GetSpacing(GID.i)
    ProcedureReturn TBEx()\Spacing
  EndProcedure
  
  Procedure.i GetRadius(GID.i)
    ProcedureReturn TBEx()\Radius
  EndProcedure
  
  Procedure.i GetDisplayMode(GID.i)
    ProcedureReturn TBEx()\DisplayMode
  EndProcedure  

  Procedure.i GetReturnValue(GID.i)
    ProcedureReturn TBEx()\ReturnValue
  EndProcedure  
  
  Procedure.i GetPopupMenu(GID.i)
    ProcedureReturn TBEx()\Popup
  EndProcedure  
  
  Procedure.i GetFontID(GID.i)
    ProcedureReturn TBEx()\Flags
  EndProcedure  
  
  Procedure.i GetLatchItem(GID.i)
    ProcedureReturn TBEx()\Mouse\LatchItem
  EndProcedure  
  
  Procedure.i GetViewWidth(GID.i)
    ProcedureReturn TBEx()\View\Width
  EndProcedure  
  
  Procedure.i GetViewHeight(GID.i)
    ProcedureReturn TBEx()\View\Height
  EndProcedure  
  
  Procedure.i GetFitWidth(GID.i)
    ProcedureReturn TBEx()\Ideal\Width
  EndProcedure  
  
  Procedure.i GetFitHeight(GID.i)
    ProcedureReturn TBEx()\Ideal\Height
  EndProcedure  
  
  
  Procedure SetColor(GID.i, ColorType.i, Color.i=#PB_Default)
    ; Set an ToolBarEx color or reset to default
    
    If FindMapElement(TBEx(), Str(GID))
      
      If Color = #PB_Default ;{ Default Colors
        Select ColorType
          Case #BackColor
            TBEx()\Color\Back = GadgetDefault\BackColor
            Refresh(GID, #Redraw|#Colors)
          Case #TextColor
            TBEx()\Color\Text = GadgetDefault\TextColor
            Refresh(GID, #Redraw|#Colors)
          Case #DividerColor
            TBEx()\Color\Div = GadgetDefault\DividerColor
            Refresh(GID, #Redraw|#Colors)
          Case #HighlightColor
            TBEx()\Color\High = GadgetDefault\HighlightColor
            Refresh(GID, #Redraw|#Colors)
          Case #LatchColor
            TBEx()\Color\Latch = GadgetDefault\LatchColor
            If TBEx()\Mouse\LatchItem >= 0 : Refresh(GID, #Redraw|#Colors) : EndIf
        EndSelect ;}
      EndIf
      
      If Color >= 0
        Select (ColorType)
          Case #BackColor
            TBEx()\Color\Back = Color
            Refresh(GID, #Redraw|#Colors)
          Case #TextColor
            TBEx()\Color\Text = Color
            Refresh(GID, #Redraw|#Colors)
          Case #DividerColor
            TBEx()\Color\Div = Color 
            Refresh(GID, #Redraw|#Colors)
          Case #HighlightColor
            TBEx()\Color\High = Color
            Refresh(GID, #Redraw|#Colors)
          Case #LatchColor
            TBEx()\Color\Latch = Color
            If TBEx()\Mouse\LatchItem >= 0 : Refresh(GID, #Redraw|#Colors) : EndIf
        EndSelect
      EndIf
      
    EndIf
    
  EndProcedure  
  
  Procedure SetLatchItem(GID.i, ItemNumber.i=#None)
    ; Specify a latched item by its item number (not its position number)
    If ItemNumber >= 0 And ItemNumber < TBEx()\NumItems
      TBEx()\Mouse\LatchItem = ItemNumber
    Else
      TBEx()\Mouse\LatchItem = #None
    EndIf
  EndProcedure
  
  Procedure SetFont(GID.i, FontID.i=#PB_Default)
    ; Specify a custom font by its FontID (not its PB font number)
    TBEx()\FontID     = FontID
    TBEx()\Text\Height = #Invalid
    ForEach TBEx()\Pos()
      If TBEx()\Pos()\Type = #Item
        FormatText(GID)
      EndIf
    Next
    Refresh(GID, #Update|#Redraw)
  EndProcedure
 
  Procedure SetPopupMenu(GID.i, Menu.i=#PB_Default)
    ; Specify a PB popup menu to automatically appear on right-clicks
    TBEx()\Popup = Menu
  EndProcedure
  
  Procedure SetReturnValue(GID.i, ReturnValue.i=#PB_Default)
    ; Set the Return Value mode (see constants)
    Select ReturnValue
      Case #ItemNumber, #Position, #UserData
        TBEx()\ReturnValue = ReturnValue
    EndSelect
  EndProcedure
  
  Procedure SetMouseOverEvents(GID.i, State.i=#True)
    
    If FindMapElement(TBEx(), Str(GID))
    
      If State
        TBEx()\Flags | #MouseOverEvents
      Else
        TBEx()\Flags & ~#MouseOverEvents
      EndIf
      
    EndIf
 
  EndProcedure
  
  Procedure SetDisplayMode(GID.i, Mode.i=#PB_Default)
    ; Set the Display Mode (see constants)
    Select Mode
      Case #ImageOnly, #ImageAndText, #TextOnly
        TBEx()\DisplayMode = Mode
        Refresh(GID, #Update|#Redraw)
    EndSelect
  EndProcedure

  Procedure SetRadius(GID.i, Size.i=#PB_Default)
    ; Set the highlight corner radius (0 = no rounded corners)
    If Size >= 0
      TBEx()\Radius = Size
      Refresh(GID, #Redraw)
    EndIf
  EndProcedure

  Procedure SetSpacing(GID.i, Size.i=#PB_Default)
    ; Set the button spacing (empty pixels between buttons and dividers)
    If Size >= 0
      TBEx()\Spacing = Size
      Refresh(GID, #Update|#Redraw)
    EndIf
  EndProcedure

  Procedure SetPadding(GID.i, Size.i=#PB_Default)
    ; Set the button padding (pixels between buttons and dividers)
    If Size >= 0
      TBEx()\Padding = Size
      Refresh(GID, #Update|#Redraw)
    EndIf
  EndProcedure
  
  Procedure SetMargin(GID.i, Size.i=#PB_Default)
    ; Set the margin (empty pixels between buttons and gadget border)
    
    If Size >= 0
      TBEx()\Margin = Size
      Refresh(GID, #Update|#Redraw)
    EndIf
    
  EndProcedure
  
  ;- ----- Procedures -------------
  
  Procedure ToolBarExCallback()
    Define.i i, mX, mY, Item, PreHover, Redraw = #False
    Define.s Tip = ""
    Define.i GID = EventGadget()
    
    If FindMapElement(TBEx(), Str(GID))
      
      PreHover = TBEx()\Mouse\HoverItem

      Select EventType()
        Case #PB_EventType_MouseMove, #PB_EventType_MouseEnter ;{
          
          If TBEx()\NumPositions And Not (TBEx()\Flags & (#TBEx_Hidden|#TBEx_Disabled))
            
            mX = GetGadgetAttribute(GID, #PB_Canvas_MouseX)
            mY = GetGadgetAttribute(GID, #PB_Canvas_MouseY)
            Item = #None
            
            ForEach TBEx()\Pos()
              If TBEx()\Pos()\Type = #Item
                If Not (TBEx()\Pos()\Flags & #TBEx_Disabled)
                  If TBEx()\Mouse\LatchItem <> TBEx()\Pos()\ItemNumber
                    If mX >= TBEx()\Pos()\X And (mX < TBEx()\Pos()\X + TBEx()\Pos()\Width)
                      If mY >= TBEx()\Pos()\Y And (mY < TBEx()\Pos()\Y + TBEx()\Pos()\Height)
                        Item = ListIndex(TBEx()\Pos())
                        Tip  = TBEx()\Pos()\Tip
                        Break
                      EndIf
                    EndIf
                  EndIf
                EndIf
              EndIf
            Next
            
            TBEx()\Mouse\HoverItem = Item
            
          Else
            
            TBEx()\Mouse\State     = #Hovering
            TBEx()\Mouse\HoverItem = #None
            
          EndIf
          ;}
        Case #PB_EventType_MouseLeave     ;{
          
          TBEx()\Mouse\State     = #Hovering
          TBEx()\Mouse\HoverItem = #None
          TBEx()\Mouse\ClickItem = #None
          ;}
        Case #PB_EventType_LeftButtonDown ;{
          If Not (TBEx()\Flags & #TBEx_Disabled)
            If TBEx()\Mouse\State = #Hovering And TBEx()\Mouse\HoverItem >= 0
              TBEx()\Mouse\State  = #Clicking
              TBEx()\Mouse\ClickItem = TBEx()\Mouse\HoverItem
              Redraw = #True
            EndIf
          EndIf ;}
        Case #PB_EventType_LeftButtonUp   ;{
          
          If Not (TBEx()\Flags & #TBEx_Disabled)
            
            i = #None
            
            If TBEx()\Mouse\State = #Clicking
              If TBEx()\Mouse\HoverItem = TBEx()\Mouse\ClickItem
                i = TBEx()\Mouse\ClickItem
                SelectElement(TBEx()\Pos(), TBEx()\Mouse\ClickItem)
              EndIf
              Redraw = #True
            EndIf
            
            If i >= 0
              Select TBEx()\ReturnValue
                Case #Position
                  ; i = i
                Case #UserData
                  i = TBEx()\Pos()\UserData
                Default
                  i = TBEx()\Pos()\ItemNumber
              EndSelect
              If TBEx()\Pos()\MenuID >= 0
                PostEvent(#PB_Event_Menu, TBEx()\WinID, TBEx()\Pos()\MenuID)
              EndIf
            EndIf
            
          EndIf
          
          TBEx()\Mouse\State = #Hovering
          ;}
        Case #PB_EventType_RightClick     ;{
          If Not (TBEx()\Flags & #TBEx_Disabled)
            If TBEx()\Popup <> #None And IsMenu(TBEx()\Popup)
              DisplayPopupMenu(TBEx()\Popup, WindowID(TBEx()\WinID))
            EndIf
          EndIf
          ;}
      EndSelect
      
      If TBEx()\Mouse\HoverItem <> PreHover
        
        If TBEx()\Flags & #MouseOverEvents
          
          If TBEx()\Mouse\HoverItem >= 0
            SelectElement(TBEx()\Pos(), TBEx()\Mouse\HoverItem)
            PostEvent(#PB_Event_Gadget, TBEx()\WinID, GID, #EventType_MouseOver, TBEx()\Pos()\ItemNumber)
          Else
            PostEvent(#PB_Event_Gadget, TBEx()\WinID, GID, #EventType_MouseOver, #None)
          EndIf
          
        EndIf
        
        If TBEx()\Mouse\HoverItem >= 0
          GadgetToolTip(GID, Tip)
        Else
          GadgetToolTip(GID, "")
        EndIf
        
        Redraw = #True
        
      EndIf
      
      If Redraw : Redraw(GID) : EndIf
      
    EndIf
    
  EndProcedure

  Procedure GadgetDefaults()
    Define.i TempGadget
    
    CompilerIf #PB_Compiler_OS = #PB_OS_MacOS    ; Default font
      If GadgetDefault\Font = #Null
        TempGadget = TextGadget(#PB_Any, 0, 0, 0, 0, "")
        If TempGadget
          GadgetDefault\FontID = GetGadgetFont(TempGadget)
          FreeGadget(TempGadget)
        EndIf
      EndIf
    CompilerElse
      GadgetDefault\FontID = GetGadgetFont(#PB_Default)
    CompilerEndIf

    CompilerIf #PB_Compiler_OS = #PB_OS_Windows  ; Background Color
      GadgetDefault\BackColor = GetSysColor_(#COLOR_MENU)
    CompilerElse
      GadgetDefault\BackColor = $EDEDED
    CompilerEndIf

    CompilerIf #PB_Compiler_OS = #PB_OS_Windows  ; Text Color
      GadgetDefault\TextColor = GetSysColor_(#COLOR_MENUTEXT)
    CompilerElse
      GadgetDefault\TextColor = $000000
    CompilerEndIf

    CompilerIf #PB_Compiler_OS = #PB_OS_Windows  ; Divider Color
      GadgetDefault\DividerColor = GetSysColor_(#COLOR_3DSHADOW)
    CompilerElse
      GadgetDefault\DividerColor = $A0A0A0
    CompilerEndIf

    CompilerIf #PB_Compiler_OS = #PB_OS_Windows  ; Highlight Color
      GadgetDefault\HighlightColor = GetSysColor_(#COLOR_MENUHILIGHT)
    CompilerElse
      GadgetDefault\HighlightColor = $FF8000
    CompilerEndIf
 
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows  ; Latch Color
      GadgetDefault\LatchColor = GetSysColor_(#COLOR_3DLIGHT)
    CompilerElse
      GadgetDefault\LatchColor = $F8F8F8
    CompilerEndIf

    GadgetDefault\Margin  = 2
    GadgetDefault\Padding = 3
    GadgetDefault\Spacing = 0
    GadgetDefault\Radius  = 0
    GadgetDefault\UserData        = #Null
    GadgetDefault\PopupMenu       = #None
    GadgetDefault\DisplayMode     = #ImageOnly
    GadgetDefault\ReturnValue     = #ItemNumber
    GadgetDefault\MouseOverEvents = #False

  EndProcedure  
  
  Procedure.i Max(Value1.i, Value2.i)
    If Value1 < Value2 : Value1 = Value2 : EndIf
    ProcedureReturn Value1
  EndProcedure
  
  Procedure FormatText(GID.i)
    Define Build.s, Line.s, i.i
    
    TBEx()\Pos()\Text  = ReplaceString(TBEx()\Pos()\Text, #TAB$, " " )
    TBEx()\Pos()\Text  = ReplaceString(TBEx()\Pos()\Text, #CRLF$, #LF$)
    TBEx()\Pos()\Text  = ReplaceString(TBEx()\Pos()\Text, #CR$, #LF$)
    TBEx()\Pos()\Lines = CountString(TBEx()\Pos()\Text,   #LF$) + 1
    TBEx()\Pos()\Tip   = ReplaceString(TBEx()\Pos()\Tip,  #LF$, " ")
    
    If StartDrawing(CanvasOutput(GID))
      
      DrawingFont(TBEx()\FontID)
      
      If TBEx()\Pos()\Lines = 1
        TBEx()\Pos()\Text      = Trim(TBEx()\Pos()\Text)
        TBEx()\Pos()\TextWidth = TextWidth(TBEx()\Pos()\Text)
      Else
        TBEx()\Pos()\TextWidth = 0
        For i = 1 To TBEx()\Pos()\Lines
          Line = Trim(StringField(TBEx()\Pos()\Text, i, #LF$))
          TBEx()\Pos()\TextWidth = Max(TBEx()\Pos()\TextWidth, TextWidth(Line))
          Build + #LF$ + Line
        Next
        TBEx()\Pos()\Text = Mid(Build, 2)
      EndIf
      
      StopDrawing()
    EndIf
    
  EndProcedure

  Procedure Redraw(GID.i, Force.i=#False)
    Define.i DrawingID, ImageAlpha, TextColor
    Define.i i, Border, Shade, Back
    Define.s LineText
    
    If FindMapElement(TBEx(), Str(GID))
      
      If TBEx()\Flags & (#TBEx_Locked|#TBEx_Hidden) = #False Or Force
        
        DrawingID = StartDrawing(CanvasOutput(GID))
        If DrawingID
          
          Box(0, 0, OutputWidth(), OutputHeight(), TBEx()\Color\Back)
          
          If TBEx()\NumPositions
            
            CompilerIf #TBEx_UseWinAPIText
              SelectObject_(DrawingID, TBEx()\FontID)
            CompilerEndIf
            
            DrawingFont(TBEx()\FontID)
            
            ForEach TBEx()\Pos()
              If TBEx()\Pos()\Type = #Divider
                Box(TBEx()\Pos()\X + TBEx()\Padding, TBEx()\Pos()\Y + TBEx()\Padding, TBEx()\Pos()\Width - 2 * TBEx()\Padding, TBEx()\Pos()\Height - 2 * TBEx()\Padding, TBEx()\Color\Div)
              EndIf
            Next
            
            ForEach TBEx()\Pos()
              
              If TBEx()\Flags & #TBEx_Disabled Or TBEx()\Pos()\Flags & #TBEx_Disabled
                ImageAlpha = 128
                TextColor  = TBEx()\Color\TextDisabled
              Else
                ImageAlpha = 255
                TextColor  = TBEx()\Color\Text
              EndIf
                
              If TBEx()\Pos()\Type = #Item
                
                Border = #False
                Shade  = #False
                Back   = TBEx()\Color\Back
                
                If TBEx()\Pos()\ItemNumber = TBEx()\Mouse\LatchItem
                  Shade = #True
                  Back  = TBEx()\Color\Latch
                ElseIf TBEx()\Mouse\State = #Hovering
                  If (TBEx()\Mouse\HoverItem = ListIndex(TBEx()\Pos()))
                    Back = TBEx()\Color\Fade
                    Border = #True
                  EndIf
                ElseIf TBEx()\Mouse\State = #Clicking
                  If TBEx()\Mouse\HoverItem = TBEx()\Mouse\ClickItem And TBEx()\Mouse\HoverItem = ListIndex(TBEx()\Pos())
                    Back   = TBEx()\Color\Click
                    Border = #True
                  EndIf
                EndIf
                
                If Shade : Box(TBEx()\Pos()\X, TBEx()\Pos()\Y, TBEx()\Pos()\Width, TBEx()\Pos()\Height, Back) : EndIf
                
                If Border
                  If TBEx()\Radius > 0
                    RoundBox(TBEx()\Pos()\X, TBEx()\Pos()\Y, TBEx()\Pos()\Width, TBEx()\Pos()\Height, TBEx()\Radius, TBEx()\Radius, Back)
                  Else
                    Box(TBEx()\Pos()\X, TBEx()\Pos()\Y, TBEx()\Pos()\Width, TBEx()\Pos()\Height, Back)
                  EndIf
                EndIf
                
                If TBEx()\DisplayMode <> #TextOnly
                  If TBEx()\Pos()\Image <> #None
                    DrawAlphaImage(ImageID(TBEx()\Pos()\Image), TBEx()\Pos()\X + (TBEx()\Pos()\Width - TBEx()\Pos()\ImgWidth)/2, TBEx()\Pos()\Y + TBEx()\Padding + (TBEx()\MaxImg\Height - TBEx()\Pos()\ImgHeight)/2, ImageAlpha)
                  EndIf
                EndIf
                
                If TBEx()\DisplayMode <> #ImageOnly
                  If TBEx()\Pos()\Lines = 1
                    _TBExText(DrawingID, TBEx()\Pos()\X + (TBEx()\Pos()\Width - TBEx()\Pos()\TextWidth)/2, TBEx()\Pos()\Y + TBEx()\Padding + TBEx()\MaxImg\Height + (TBEx()\MaxText\Height - TBEx()\Text\Height)/2, TBEx()\Pos()\Text, TextColor, Back)
                  Else
                    For i = 1 To TBEx()\Pos()\Lines
                      LineText = StringField(TBEx()\Pos()\Text, i, #LF$)
                      _TBExText(DrawingID, TBEx()\Pos()\X + (TBEx()\Pos()\Width - TextWidth(LineText))/2, TBEx()\Pos()\Y + TBEx()\Padding + TBEx()\MaxImg\Height + (TBEx()\MaxText\Height - (TBEx()\Text\Height * TBEx()\Pos()\Lines))/2 + (i-1) * TBEx()\Text\Height, LineText, TextColor, Back)
                    Next i
                  EndIf
                EndIf
                
                If Border
                  DrawingMode(#PB_2DDrawing_Outlined)
                  If TBEx()\Radius > 0
                    RoundBox(TBEx()\Pos()\X, TBEx()\Pos()\Y, TBEx()\Pos()\Width, TBEx()\Pos()\Height, TBEx()\Radius, TBEx()\Radius, TBEx()\Color\High)
                  Else
                    Box(TBEx()\Pos()\X, TBEx()\Pos()\Y, TBEx()\Pos()\Width, TBEx()\Pos()\Height, TBEx()\Color\High)
                  EndIf
                  DrawingMode(#PB_2DDrawing_Default)
                EndIf
                
              EndIf
              
            Next
            
          EndIf
          
          StopDrawing()
        EndIf
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure Update(GID.i, Redraw.i = #False)
    Define.i X, Y, ItemWidth, ItemHeight
    Define.i FreeSpace, SpacingToAdd, NumSpacers = 0
    
    If FindMapElement(TBEx(), Str(GID))
      
      TBEx()\View\Width  = GadgetWidth(GID)
      TBEx()\View\Height = GadgetHeight(GID)
      
      If TBEx()\Text\Height <= 0
        If StartDrawing(CanvasOutput(GID))
          DrawingFont(TBEx()\FontID)
          TBEx()\Text\Height = TextHeight("ABC123")
          StopDrawing()
        EndIf
      EndIf
      
      TBEx()\Ideal\Width  = 0
      TBEx()\Ideal\Height = 0
      TBEx()\Used\Width   = 0
      TBEx()\Used\Height  = 0
      
      TBEx()\MaxImg\Width   = 0
      TBEx()\MaxImg\Height  = 0
      TBEx()\MaxText\Width  = 0
      TBEx()\MaxText\Height = 0
      
      ForEach TBEx()\Pos()
        
        If ListIndex(TBEx()\Pos()) >= 1
          SpacingToAdd = TBEx()\Spacing
        Else
          SpacingToAdd = 0
        EndIf
        
        Select TBEx()\Pos()\Type
          Case #Item    ;{ ToolBarEx - Item
            ItemWidth = 0
            If TBEx()\DisplayMode = #ImageOnly
              ItemHeight = TBEx()\Text\Height
            Else
              ItemHeight = TBEx()\Text\Height * TBEx()\Pos()\Lines
            EndIf
            Select TBEx()\DisplayMode
              Case #ImageOnly
                TBEx()\MaxImg\Width  = Max(TBEx()\MaxImg\Width,  TBEx()\Pos()\ImgWidth)
                TBEx()\MaxImg\Height = Max(TBEx()\MaxImg\Height, TBEx()\Pos()\ImgHeight)
                ItemWidth  = Max(ItemWidth,  TBEx()\Pos()\ImgWidth)
                ItemHeight = Max(ItemHeight, TBEx()\Pos()\ImgHeight)
              Case #ImageAndText
                TBEx()\MaxText\Width  = Max(TBEx()\MaxText\Width,  TBEx()\Pos()\TextWidth)
                TBEx()\MaxText\Height = Max(TBEx()\MaxText\Height, ItemHeight)
                TBEx()\MaxImg\Width   = Max(TBEx()\MaxImg\Width,   TBEx()\Pos()\ImgWidth)
                TBEx()\MaxImg\Height  = Max(TBEx()\MaxImg\Height,  TBEx()\Pos()\ImgHeight)
                ItemWidth = Max(ItemWidth, TBEx()\Pos()\ImgWidth)
                ItemWidth = Max(ItemWidth, TBEx()\Pos()\TextWidth) 
                ItemHeight + TBEx()\Pos()\ImgHeight
              Case #TextOnly
                TBEx()\MaxText\Width  = Max(TBEx()\MaxText\Width,  TBEx()\Pos()\TextWidth)
                TBEx()\MaxText\Height = Max(TBEx()\MaxText\Height, ItemHeight)
                ItemWidth = TBEx()\Pos()\TextWidth
            EndSelect
            ItemWidth + TBEx()\Padding * 2
            ;}
          Case #Divider ;{ ToolBarEx - Divider
            ItemWidth  = 1 + TBEx()\Padding * 2
            ItemHeight = TBEx()\Text\Height
            ;}
          Case #Spacer  ;{ ToolBarEx - Spacer
            If TBEx()\Pos()\TextWidth = #PB_Default
              NumSpacers + 1
              ItemWidth  = 0
            Else
              ItemWidth = TBEx()\Pos()\TextWidth
            EndIf
            ItemHeight  = TBEx()\Text\Height
            SpacingToAdd = 0
            ;}
        EndSelect
        
        ItemHeight + TBEx()\Padding * 2
        
        If Not (TBEx()\Flags & #TBEx_SizeLock)
          TBEx()\Pos()\Width  = ItemWidth
          TBEx()\Pos()\Height = ItemHeight
        EndIf
        
        TBEx()\Ideal\Width + ItemWidth + SpacingToAdd
        TBEx()\Ideal\Height = Max(TBEx()\Ideal\Height, ItemHeight)
        
      Next
      
      TBEx()\Ideal\Width  + (TBEx()\Margin * 2)
      TBEx()\Ideal\Height + (TBEx()\Margin * 2)
      
      FreeSpace = TBEx()\View\Width - TBEx()\Ideal\Width
      
      TBEx()\Used\Width  = TBEx()\Margin * 2
      TBEx()\Used\Height = TBEx()\Ideal\Height
      
      X = TBEx()\Margin
      Y = TBEx()\Margin
      
      ForEach TBEx()\Pos()
        
        TBEx()\Pos()\X = X
        TBEx()\Pos()\Y = Y
        
        If Not (TBEx()\Flags & #TBEx_SizeLock)
          TBEx()\Pos()\Height = TBEx()\Ideal\Height - (TBEx()\Margin * 2)
        EndIf
        
        If TBEx()\Pos()\Type = #Spacer
          
          If ListIndex(TBEx()\Pos()) >= 1
            X - TBEx()\Spacing
            TBEx()\Pos()\X - TBEx()\Spacing
          EndIf
          
          If TBEx()\Pos()\TextWidth = #PB_Default And FreeSpace > 0
            TBEx()\Pos()\Width = FreeSpace / NumSpacers
            FreeSpace  - TBEx()\Pos()\Width
            NumSpacers - 1
          EndIf
          
          TBEx()\Used\Width + TBEx()\Pos()\Width
          
        Else
          
          TBEx()\Used\Width + TBEx()\Pos()\Width
          
        EndIf
        
        X + TBEx()\Pos()\Width + TBEx()\Spacing
        
      Next
      
      If Redraw : Redraw(GID) : EndIf
      
    EndIf
    
  EndProcedure  
  
  Procedure CalculateColors(GID.i)
    Define.i R, G, B
    
    If FindMapElement(TBEx(), Str(GID))
  
      R = Red(TBEx()\Color\High)   * 0.2 + Red(TBEx()\Color\Back)   * 0.8
      G = Green(TBEx()\Color\High) * 0.2 + Green(TBEx()\Color\Back) * 0.8
      B = Blue(TBEx()\Color\High)  * 0.2 + Blue(TBEx()\Color\Back)  * 0.8
      TBEx()\Color\Fade = RGB(R, G, B)
      
      R = Red(TBEx()\Color\High)   * 0.3 + Red(TBEx()\Color\Back)   * 0.7
      G = Green(TBEx()\Color\High) * 0.3 + Green(TBEx()\Color\Back) * 0.7
      B = Blue(TBEx()\Color\High)  * 0.3 + Blue(TBEx()\Color\Back)  * 0.7
      TBEx()\Color\Click = RGB(R, G, B)
      
      R = Red(TBEx()\Color\Text)   * 0.4 + Red(TBEx()\Color\Back)   * 0.6
      R + Green(TBEx()\Color\Text) * 0.4 + Green(TBEx()\Color\Back) * 0.6
      R + Blue(TBEx()\Color\Text)  * 0.4 + Blue(TBEx()\Color\Back)  * 0.6
      R = R / 3
      G = R
      B = R
      TBEx()\Color\TextDisabled = RGB(R, G, B)
      
    EndIf
    
  EndProcedure
  
  Procedure.i Gadget(WinID.i, GadgetID.i, X.i, Y.i, Width.i, Height.i, DisplayMode.i=#PB_Default)
    ; Create an ToolBarEx:
    ; - x, y: position coordinates
    ; - Width, Height: gadget dimensions
    ; - DisplayMode: ImageOnly (Default), ImageAndText, or TextOnly (see constants)
    ; - Window: PB window to report events to (default is 0 - window number, not handle)
    Define GID.i
    
    If IsWindow(WinID)
      
      GID = CanvasGadget(GadgetID, X, Y, Width, Height)
      If GID
        
        If GadgetID = #PB_Any : GadgetID = GID : EndIf
        
        AddMapElement(TBEx(), Str(GadgetID))
        
        If DisplayMode = #PB_Default
          DisplayMode = GadgetDefault\DisplayMode
        EndIf
        
        TBEx()\WinID       = WinID
        TBEx()\FontID      = GadgetDefault\FontID
        TBEx()\ReturnValue = GadgetDefault\ReturnValue
        TBEx()\Popup       = GadgetDefault\PopupMenu
        TBEx()\Color\Back  = GadgetDefault\BackColor
        TBEx()\Color\Text  = GadgetDefault\TextColor
        TBEx()\Color\Div   = GadgetDefault\DividerColor
        TBEx()\Color\High  = GadgetDefault\HighlightColor
        TBEx()\Color\Latch = GadgetDefault\LatchColor
        TBEx()\Margin      = GadgetDefault\Margin
        TBEx()\Padding     = GadgetDefault\Padding
        TBEx()\Spacing     = GadgetDefault\Spacing
        TBEx()\Radius      = GadgetDefault\Radius
        TBEx()\DisplayMode = DisplayMode
        TBEx()\Mouse\State       = #Hovering
        TBEx()\Mouse\HoverItem   = #None
        TBEx()\Mouse\ClickItem   = #None
        TBEx()\Mouse\LatchItem   = #None
        
        CalculateColors(GadgetID)
        Update(GadgetID, #True)
        
        BindGadgetEvent(GadgetID, @ToolBarExCallback())
        
        ProcedureReturn GadgetID
      EndIf
    EndIf

  EndProcedure
  
  GadgetDefaults()
  
EndModule

 ;- ========================================================================================================


;- [ Demo Program ]

CompilerIf (#PB_Compiler_IsMainFile)

  DisableExplicit
  
  UsePNGImageDecoder()
  
  Enumeration
    #WIN
    #TB1
    #TB2
    #TB3
    #TB4
    #TB5
    #Menu
  EndEnumeration
  
  If FileSize("page_white.png") < 0
    MessageRequester("ToolBarEx Demo", "You should download the images for a correct demo!")
  EndIf

  If OpenWindow(#WIN, 0, 0, 640, 530, "ToolBarEx Demo ", #PB_Window_ScreenCentered|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget)
    CreateStatusBar(#WIN, WindowID(#WIN))
    AddStatusBarField(#PB_Ignore)
    AddKeyboardShortcut(#WIN, #PB_Shortcut_Escape, 0)
    WindowBounds(#WIN, #PB_Ignore, WindowHeight(0), #PB_Ignore, WindowHeight(0))
  EndIf
  
  LoadImage(0, "page_white.png")
  LoadImage(1, "folder_vertical_open.png")
  LoadImage(2, "disk.png")
  LoadImage(3, "page_white_copy.png")
  LoadImage(4, "page_white_paste.png")
  LoadImage(5, "cut.png")
  LoadImage(6, "world.png")
  LoadImage(7, "help.png")
  LoadImage(8, "world_16.png")
  LoadImage(9, "star_16.png")

  y = 10

  ;- - Create ToolBarEx 1

  TextGadget(#PB_Any, 20, y, WindowWidth(#WIN) - 20, 20, "Default style (icons with tooltips) with 1 divider and 1 spacer:")
  If ToolBar::Gadget(#WIN, #TB1, 0, y+20, WindowWidth(#WIN), 20)
    ToolBar::AddItem(#TB1, "New",  0)
    ToolBar::AddItem(#TB1, "Open", 1)
    ToolBar::AddItem(#TB1, "Save", 2)
    ToolBar::Divider(#TB1)
    ToolBar::AddItem(#TB1, "Copy",  3)
    ToolBar::AddItem(#TB1, "Paste", 4)
    ToolBar::AddItem(#TB1, "Cut",   5)
    ToolBar::Spacer(#TB1)
    ToolBar::AddItem(#TB1, "Website", 6)
    ToolBar::AddItem(#TB1, "Help",    7)
  EndIf
  
  y + ToolBar::Resize(#TB1, #PB_Ignore, #PB_Ignore, #PB_Ignore, ToolBar::#Auto)
  y + 20 + 30
  
  ;- - Create ToolBarEx 2

  TextGadget(#PB_Any, 20, y, WindowWidth(#WIN)-20, 20, "Images and Text, using 2 spacers to center, latch item, disabled item, returns click position:")
  If ToolBar::Gadget(#WIN, #TB2, 0, y+20, WindowWidth(#WIN), 20, ToolBar::#ImageAndText)
    ToolBar::Spacer(#TB2)
    ToolBar::AddItem(#TB2, "New",  0)
    ToolBar::AddItem(#TB2, "Open", 1)
    ToolBar::AddItem(#TB2, "Save", 2)
    ToolBar::Divider(#TB2)
    ToolBar::AddItem(#TB2, "Copy",  3)
    ToolBar::AddItem(#TB2, "Paste", 4)
    ToolBar::AddItem(#TB2, "Cut",   5)
    ToolBar::Spacer(#TB2)
    ToolBar::SetReturnValue(#TB2, ToolBar::#Position)
    ToolBar::SetLatchItem(#TB2, 0)
    ToolBar::DisableItem(#TB2, 2)
  EndIf
  
  y + ToolBar::Resize(#TB2, #PB_Ignore, #PB_Ignore, #PB_Ignore, ToolBar::#Auto)
  y + 20 + 30
  
  ;- - Create ToolBarEx 3

  TextGadget(#PB_Any, 20, y, WindowWidth(#WIN) - 20, 20, "Text only, with right-click menu, returns custom values:")
  If ToolBar::Gadget(#WIN, #TB3, 0, y+20, WindowWidth(#WIN), 20, ToolBar::#TextOnly)
    ToolBar::AddItem(#TB3, "New",  ToolBar::#None, 123)
    ToolBar::AddItem(#TB3, "Open", ToolBar::#None, 456)
    ToolBar::AddItem(#TB3, "Save", ToolBar::#None, 789)
    ToolBar::Divider(#TB3)
    ToolBar::AddItem(#TB3, "Copy",  ToolBar::#None, 42)
    ToolBar::AddItem(#TB3, "Paste", ToolBar::#None, 555)
    ToolBar::AddItem(#TB3, "Cut",   ToolBar::#None, 1024)
    ToolBar::Divider(#TB3)
    ToolBar::AddItem(#TB3, "Website", ToolBar::#None, 1000)
    ToolBar::AddItem(#TB3, "Help",    ToolBar::#None, 1001)
    ToolBar::Divider(#TB3)
    ToolBar::AddItem(#TB3, "Quit", ToolBar::#None, 999, 0)
    ToolBar::SetItemText(#TB3, "Click to actually Quit the demo!", ToolBar::#Last, ToolBar::#ToolTip)
  EndIf
  
  CreatePopupMenu(#Menu)
  MenuItem(#Menu, "Quit Demo")
  
  ToolBar::SetPopupMenu(#TB3, #Menu)
  ToolBar::SetReturnValue(#TB3, ToolBar::#UserData)
  
  y + ToolBar::Resize(#TB3, #PB_Ignore, #PB_Ignore, #PB_Ignore, ToolBar::#Auto)
  y + 20 + 30
  
  ;- - Create ToolBarEx 4

  TextGadget(#PB_Any, 20, y, WindowWidth(#WIN) - 20, 20, "Multi-line, custom font, various icon sizes, missing image, custom colors, rounded corners:")
  If ToolBar::Gadget(#WIN, #TB4, 0, y+20, WindowWidth(#WIN), 20, ToolBar::#ImageAndText)
    ToolBar::AddItem(#TB4, "Blank"   + #LF$ + "Page", 0)
    ToolBar::AddItem(#TB4, "Another" + #LF$ + "Page", 0)
    ToolBar::AddItem(#TB4, "Missing" + #LF$ + "Image")
    ToolBar::Spacer(#TB4)
    ToolBar::AddItem(#TB4, "A", 9)
    ToolBar::AddItem(#TB4, "B", 9)
    ToolBar::AddItem(#TB4, "C", 9)
    ToolBar::Spacer(#TB4)
    ToolBar::AddItem(#TB4, "Hello" + #LF$ + "World", 6)
    ToolBar::AddItem(#TB4, "Small" + #LF$ + "World", 8)
    ToolBar::SetFont(#TB4, LoadFont(0, "Georgia", 10))
    ToolBar::SetRadius(#TB4, 7)
  EndIf
  
  y + ToolBar::Resize(#TB4, #PB_Ignore, #PB_Ignore, #PB_Ignore, ToolBar::#Auto)
  y + 20 + 30
  y + 20

  ;- - Create ToolBarEx 5

  TextGadget(#PB_Any, 20, y, WindowWidth(#WIN)-20, 20, "ToolBarEx acting as a single button, with custom ToolTip:")
  If ToolBar::Button(#WIN, #TB5, 10, y+20, 20, 20, 7, "Disable", ToolBar::#ImageAndText)
    ToolBar::AutoSize(#TB5)
    ToolBar::SetItemText(#TB5, "Click to disable/enable the above ToolBarEx", 0, ToolBar::#ToolTip)
  EndIf  
  
  ToolBar::SetMouseOverEvents(#TB1, #True)
  ToolBar::SetMouseOverEvents(#TB2, #True)
  ToolBar::SetMouseOverEvents(#TB3, #True)
  ToolBar::SetMouseOverEvents(#TB4, #True)
  ToolBar::SetMouseOverEvents(#TB5, #True)

  Procedure ResizeCallback()
    If GetWindowState(#WIN) <> #PB_Window_Minimize
      ToolBar::Resize(#TB1, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN), #PB_Ignore)
      ToolBar::Resize(#TB2, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN), #PB_Ignore)
      ToolBar::Resize(#TB3, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN), #PB_Ignore)
      ToolBar::Resize(#TB4, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN), #PB_Ignore)
      ToolBar::Resize(#TB5, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN), #PB_Ignore)
    EndIf
  EndProcedure

  BindEvent(#PB_Event_SizeWindow, @ResizeCallback(), #WIN)

  Repeat
    Select (WaitWindowEvent())
      Case #PB_Event_CloseWindow
        Done = #True
      Case #PB_Event_Menu
        Done = #True
      Case #PB_Event_Gadget
        If EventType() = #PB_EventType_LeftClick
          Select EventGadget()
            Case #TB1
              Debug "TBEx 1: Clicked item " + Str(EventData())
            Case #TB2
              Debug "TBEx 2: Clicked position " + Str(EventData())
              If #False
                ToolBar::DisableItem(#TB2, ToolBar::#All, #False)
                ToolBar::DisableItem(#TB2, ToolBar::ItemNumberFromPosition(#TB2, EventData()), #True)
              Else
                ToolBar::SetLatchItem(#TB2, ToolBar::ItemNumberFromPosition(#TB2, EventData()))
              EndIf
            Case #TB3
              Debug "TBEx 3: User data = " + Str(EventData())
            Case #TB4
              ToolBar::LockRedraw(#TB4, #True)
            
              ; Random layout
              ToolBar::SetMargin(#TB4, Random(10))
              ToolBar::SetPadding(#TB4, Random(10))
              ToolBar::SetSpacing(#TB4, Random(10))
              ToolBar::SetDisplayMode(#TB4, Random(2))
              
              ; Random colors and font
              ToolBar::SetColor(#TB4, ToolBar::#BackColor, RGB(230+Random(25),230+Random(25),230+Random(25)))
              ToolBar::SetColor(#TB4, ToolBar::#TextColor, $A0 << (Random(2) * 8))
              ToolBar::SetColor(#TB4, ToolBar::#HighlightColor, Random($FFFFFF))
              ToolBar::SetFont(#TB4, LoadFont(0, "Georgia", 6+Random(10)))
              
              ; Auto-fit gadget height
              ToolBar::Resize(#TB4, #PB_Ignore, #PB_Ignore, #PB_Ignore, ToolBar::#Auto)
              
              ToolBar::LockRedraw(#TB4, #False)
            Case #TB5
              If ToolBar::Disable(#TB4, ToolBar::#Toggle)
                ToolBar::SetItemText(#TB5, "Enable")
              Else
                ToolBar::SetItemText(#TB5, "Disable")
              EndIf
          EndSelect
        ElseIf EventType() = ToolBar::#EventType_MouseOver
          If EventData() >= 0
            StatusBarText(0, 0, "MouseOver: " + ToolBar::GetItemText(EventGadget(), EventData()))
          Else
            StatusBarText(0, 0, "")
          EndIf
        EndIf
        
    EndSelect
  Until Done
  
  ToolBar::Free(#TB1, #True)
  ToolBar::Free(#TB2, #True)
  ToolBar::Free(#TB3, #True)
  ToolBar::Free(#TB4, #True)
  ToolBar::Free(#TB5, #True)
  
CompilerEndIf

; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 313
; FirstLine = 288
; Folding = -xv--------Hg--
; Markers = 105,1545
; EnableXP